typedef struct {
	char msg[1024];
	int svid;
	int clid;
} msgstack_t;

typedef struct {
	int size;
	char *msg[16];
} incstack_t;

typedef struct {
	int stage;
	int socket;
	int id, genid;
	char username[128];
	char password[128];
	char server[128];
	//char next_msg[128];
	void* event;
	HWND hwnd;
	HWND users;
	int last_ping;
	int last_icons;
	int last_response;
	int last_svr_msg;
	int last_cl_msg;
	int cl_msg;
	int send_msg_user;
	int clid, svid;
	msgstack_t* stack[16];
	
	int stack_size;
} CHAT_DATA;

typedef struct {
	int userid;
	char name[128];
	char clan[128];
	void* hTreeItem;
	incstack_t incstack;
	int inuse;
} userdata_t;


void CHAT_Cleanup(CHAT_DATA* data);
void CHAT_SendMessage(CHAT_DATA* data, void* to);

int stack_search(CHAT_DATA* user, char* msg);
int stack_addmessage(CHAT_DATA* user, char* msg, int svid, int clid);
#define stack_add(w,x,y,z) stack_addmessage(w,x,y,z)
int stack_svid(CHAT_DATA* user, int item);
int stack_clid(CHAT_DATA* user, int item);
int stack_delmessage(CHAT_DATA* user, int item);
int stack_empty(CHAT_DATA* user);

int incstack_search(incstack_t* user, char* msg);
int incstack_addmessage(incstack_t* user, char* msg);
int incstack_delmessage(incstack_t* user, int item);
int incstack_empty(incstack_t* user);
int incstack_size(incstack_t* stack);
char* incstack_getmessage(incstack_t* user, int item);
