#include <stdio.h>
#include "comm.h"
#include "resolve.h"

#include "types.h"
#include "list.h"

#include "groupshared.h"


// Function definitions
short int (*MAIN_GetServerPort)(char* addr, short otherwise);
unsigned long (*MAIN_GetServerAddr)(char* addr);
void (*MAIN_ServersListUpdateEnable)(int setting);
server_t* (*MAIN_NewServer)(char* name, char* ipaddr, char* qstat_type);
server_t* (*MAIN_AddServer)(list_t* list, server_t* svr);
void (*MAIN_ServersListUpdate)(int forced);
void (*MAIN_EmptyList)(list_t* list);
HASH* (*MAIN_HashAlloc)(void* owner, char*name, int size);



char* master = "master3.idsoftware.com:27950";

int Q3MASTER_IsPacketFor(list_t* list, SOCKADDR* addr)
{
	SOCKADDR_IN* dest_addr = (SOCKADDR_IN*)addr;
	if (dest_addr->sin_addr.s_addr == MAIN_GetServerAddr(master)
		&& dest_addr->sin_port == htons(MAIN_GetServerPort(master, 27950)) )
		return 1;
	return 0;
}

void Q3MASTER_Packet(list_t* list, unsigned char* data, int len)
{
	char* end = data + len;
	char addr[128];
	data+=strlen("\xff\xff\xff\xff" "getserversResponse");

	MAIN_ServersListUpdate(UPDATE_DISABLE);
	
	while (data < end) {
		data++; // skip the backslash
		if (end - data >=3 && memcmp(data,"EOT",3) == 0)
			break;
		sprintf(addr,"%d.%d.%d.%d:%d",(int)data[0],(int)data[1],(int)data[2],(int)data[3],(int)data[4]*256+data[5]);
		//if (memcmp(addr,"202.",4) == 0 || memcmp(addr,"203.",4) == 0)
			MAIN_AddServer(list, MAIN_NewServer(addr,addr,6));
		data += 6;
	}

	MAIN_ServersListUpdate(UPDATE_ENABLE);
	MAIN_ServersListUpdate(0);

	return;
}

void Q3MASTER_Refresh(list_t* list) {
	SOCKADDR_IN addr;

	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr = MAIN_GetServerAddr(master);
	addr.sin_port = htons(MAIN_GetServerPort(master, 27950));
	
	sendto(HashSelectInt(HASH_GLOBAL,"Global","Socket"), "\xff\xff\xff\xffgetservers\r43\r\n", 20, 0, (SOCKADDR*)&addr, sizeof(SOCKADDR_IN));

	MAIN_EmptyList(list);

	return;
}

// Create the 'Q3Master' group type
int __stdcall Init(group_shared_t* info) {

	group_t* grp = (group_t*)info->groups[0];
	group_t* def = (group_t*)info->def;

	HashInit(info->hashes,info->numHashes);

	MAIN_GetServerPort = HashSelectPtr(HASH_GLOBAL,"Funcs","GetServerPort");
	MAIN_GetServerAddr = HashSelectPtr(HASH_GLOBAL,"Funcs","GetServerAddr");
	MAIN_ServersListUpdate = HashSelectPtr(HASH_GLOBAL,"Funcs","ServersListUpdate");
	MAIN_NewServer = HashSelectPtr(HASH_GLOBAL,"Funcs","NewServer");
	MAIN_AddServer = HashSelectPtr(HASH_GLOBAL,"Funcs","AddServer");
	MAIN_EmptyList = HashSelectPtr(HASH_GLOBAL,"Funcs","EmptyList");
	MAIN_HashAlloc = HashSelectPtr(HASH_GLOBAL,"Funcs","HashAlloc");

	strcpy(grp->name, "Q3Master");
	strcpy(grp->desc, "Q3Master");
	grp->delete_list = def->delete_list;
	grp->copy_server = def->copy_server;
	grp->refresh_list = Q3MASTER_Refresh;
	grp->is_packet_for = Q3MASTER_IsPacketFor;
	grp->packet = Q3MASTER_Packet;
	grp->properties_list = grp->properties_list;
	MAIN_HashAlloc(grp,"extra",4);
	HashInsert(grp,"extra", "URL", "master3.idsoftware.com:27950",HASH_STRING);
	grp->location = grp;

	return 1;
}