#include <stdio.h>
#include "resource.h"
#include "kingpin\resource.h"
#include "types.h"
#include "shared.h"
#include <time.h>
#include "quakex.h"
#include "resolve.h"

// Obtained from the executable
SOCKET s;
char* clan_id;
unsigned long (*GetServerAddr)(char* addr);
short int (*GetServerPort)(char* addr, short otherwise);
HWND mainhwnd;


void KINGPIN_Send(server_t* svr, short port) 
{
	SOCKADDR_IN src_addr;

	src_addr.sin_family = AF_INET;
	if (svr) {
		src_addr.sin_addr.s_addr = GetServerAddr(svr->ipaddr);
		src_addr.sin_port = htons(GetServerPort(svr->ipaddr, port));
	}
	else {
		src_addr.sin_addr.s_addr = INADDR_BROADCAST;
		src_addr.sin_port = htons(port);
	}
	
	//sendto(s, "\xff\xff\xff\xffstatus", 11, 0, (SOCKADDR*)&src_addr, sizeof(SOCKADDR_IN));
	sendto(s, "\xff\xff\xff\xffstatus", 11, 0, (SOCKADDR*)&src_addr, sizeof(SOCKADDR_IN));
	
	return;
}

void KINGPIN_PrintInfo(server_t* svr, HWND mainwnd, int ignore_changes)
{
	player_t temp_p;
	HWND temp, hwnd;
	int i, j, vals[6], teams = 0;
	int frags[2], caps[2];
	char buf[128];
	char timerem[128];

	int sin = 0;

	hwnd = mainwnd;

	mainhwnd = mainwnd;

	SetDlgItemText(hwnd, IDT_HOSTNAME, GetValue(svr, "hostname") );
	if (svr->timeout >= 5) {
		SetDlgItemText(hwnd, IDT_HOSTNAME, "UNREACHABLE");
		HashDeleteAll(svr,"items");		// wipe all current settings so we get blanks
		svr->num_players = 0;
	} else if (HashCount(svr,"items") == 0) {
		svr->num_players = 0;
		SetDlgItemText(hwnd, IDT_HOSTNAME, "CONNECTING...");
	}

	SetDlgItemText(hwnd, IDT_MAPNAME, GetValue(svr, "mapname") );
	if (!strcmp( GetValue(svr, "mapname"), "") || GetValue(svr, "mapname") == NULL)
	{
		SetDlgItemText(hwnd, IDT_MAPNAME, GetValue(svr, "map") );
	
	}
	
	SetDlgItemText(hwnd, IDT_FRAGLIMIT, GetValue(svr, "fraglimit") );
	SetDlgItemText(hwnd, IDT_TIMELIMIT, GetValue(svr, "timelimit") );

	if (GetValue(svr, "gamestats")[0])
	{
		sscanf(GetValue(svr,"gamestats"), "%s", timerem);
		sprintf(buf, "%s (%s remaining)",GetValue(svr, "timelimit"),timerem);
		SetDlgItemText(hwnd,IDT_TIMELIMIT, buf);
	}

	SetDlgItemText(hwnd, IDC_CAPTURELIMIT, "Capturelimit:");
	SetDlgItemText(hwnd, IDT_CAPTURELIMIT, GetValue(svr, "capturelimit") );

	if (strcmp(GetValue(svr, "protocol"),""))
	{
		sscanf(GetValue(svr, "protocol"), "%d", &i);
		switch (i) {
			case 32: SetDlgItemText(hwnd, IDT_VERSION, "Kingpin v1.0+"); break;
			default: SetDlgItemText(hwnd, IDT_VERSION, "Kingpin");
		}
	}
	else SetDlgItemText(hwnd, IDT_VERSION, "");

	if (strcmp(GetValue(svr, "maxclients"), ""))
	{
		sprintf(buf, "%d / %s", svr->num_players, GetValue(svr, "maxclients") );
		SetDlgItemText(hwnd, IDT_PLAYERS, buf);
	}
	else SetDlgItemText(hwnd, IDT_PLAYERS, "");

	SetDlgItemText(hwnd, IDC_DMFLAGS, "DM Flags:" );
	SetDlgItemText(hwnd, IDT_DMFLAGS, GetValue(svr, "dmflags") );

	if (GetValue(svr, "gamestats")[0])
	{
		sscanf(GetValue(svr,"gamestats"), "%*s %d/%*d %d/%*d", caps,caps+1);
		if (caps[0] == caps[1])
			sprintf(buf,"Drawn at %d caps apiece.",caps[0]);
		else if (caps[1] > caps[0])
			sprintf(buf,"BLUE leads RED, %d caps to %d.",caps[1],caps[0]);
		else sprintf(buf,"RED leads BLUE, %d caps to %d.",caps[0],caps[1]);

		SetDlgItemText(hwnd,IDT_MISC,buf);
	}
	else SetDlgItemText(hwnd,IDT_MISC,"");
	
	temp = GetDlgItem(hwnd, IDL_PLAYERS);

	SendMessage(temp, LB_RESETCONTENT, 0, 0);
	
	i = 0;
	while (i < svr->num_players - 1) 
	{
		if (svr->players[i].frags < svr->players[i+1].frags)
		{
			temp_p = svr->players[i];
			svr->players[i] = svr->players[i+1];
			svr->players[i+1] = temp_p;
			i = 0;
			continue;
		}
		i++;
	}
	
	
	SendMessage(temp, LB_ADDSTRING, 0, (LPARAM)"\tFrags\tPing\tName");
		
	if (!teams)
	{
		for (i=0;i<svr->num_players;i++)
		{
			strcpy(buf,"");

			if (svr->players[i].team == 1)
				strcat(buf, "R");
			else if (svr->players[i].team == 2)
				strcat(buf, "B");
			if (svr->players[i].flag)
				strcat(buf, "F");

			if (strcmp(clan_id,""))
			{
				for (j=0;j<(int)(strlen(svr->players[i].name) - strlen(clan_id));j++)
					if (!memcmp(svr->players[i].name+j, clan_id, strlen(clan_id)))
						strcat(buf,"*");
			}
		
			strcat(buf, "\t");

			if (!ignore_changes && svr->players[i].change)
				sprintf(buf + strlen(buf), "%d (%c%d)\t%d\t%s", svr->players[i].frags, svr->players[i].change > 0 ? '+' : ' ', svr->players[i].change,svr->players[i].ping,svr->players[i].name);
			else sprintf(buf + strlen(buf), "%d\t%d\t%s", svr->players[i].frags, svr->players[i].ping,svr->players[i].name);
			SendMessage(temp, LB_ADDSTRING, 0, (LPARAM)buf);
		}
	}
	else while (teams != 4) {
		if (teams == 1) {
			SendMessage(temp, LB_ADDSTRING, 0, (LPARAM)"");
			sprintf(buf,"\tRED TEAM - %d caps, %d frags",caps[0],frags[0]);
			SendMessage(temp, LB_ADDSTRING, 0, (LPARAM)buf);
		}
		else if (teams == 2) {
			SendMessage(temp, LB_ADDSTRING, 0, (LPARAM)"");
			sprintf(buf,"\tBLUE TEAM - %d caps, %d frags",caps[1],frags[1]);
			SendMessage(temp, LB_ADDSTRING, 0, (LPARAM)buf);
		}			
		if (teams<= 2) {
			for (i=0;i<svr->num_players;i++)
			{
				strcpy(buf,"");
	
				if (svr->players[i].team != teams)
					continue;
				if (svr->players[i].flag)
					strcat(buf, "F");
	
				if (strcmp(clan_id,""))
				{
					for (j=0;j<(int)(strlen(svr->players[i].name) - strlen(clan_id));j++)
						if (!memcmp(svr->players[i].name+j, clan_id, strlen(clan_id)))
							strcat(buf,"*");
				}
		
				strcat(buf, "\t");
	
				if (!ignore_changes && svr->players[i].change)
					sprintf(buf + strlen(buf), "%d (%c%d)\t%d\t%s", svr->players[i].frags, svr->players[i].change > 0 ? '+' : ' ', svr->players[i].change,svr->players[i].ping,svr->players[i].name);
				else sprintf(buf + strlen(buf), "%d\t%d\t%s", svr->players[i].frags, svr->players[i].ping,svr->players[i].name);
				SendMessage(temp, LB_ADDSTRING, 0, (LPARAM)buf);
			}
		}
		else  {
			j = 0; vals[0] = 0;
			for (i=0;i<svr->num_players;i++)
			{
				if (j == 0)
					strcpy(buf,""); 
	
				if (svr->players[i].team != 0)
					continue;
				
				sprintf(buf+strlen(buf), "%s%s",(j==1?"\t\t":"\t"),svr->players[i].name);
				j++;
				if (j == 2) {
					if (!vals[0])
					{
						SendMessage(temp, LB_ADDSTRING, 0, (LPARAM)"");
						SendMessage(temp, LB_ADDSTRING, 0,(LPARAM)"\tSPECTATORS");
						vals[0] = 1;
					}
		
					SendMessage(temp, LB_ADDSTRING, 0, (LPARAM)buf);
					j = 0;
				}
			}
			if (j == 1) {
				if (!vals[0])
				{
					SendMessage(temp, LB_ADDSTRING, 0, (LPARAM)"");
					SendMessage(temp, LB_ADDSTRING, 0,(LPARAM)"\tSPECTATORS");
					vals[0] = 1;
				}
				SendMessage(temp, LB_ADDSTRING, 0, (LPARAM)buf);
				return;
			}
		}
		teams++;
	}

	return;
}

char* KINGPIN_Hostname(server_t* svr)
{
	return GetValue(svr, "hostname");
}

int KINGPIN_Receive(server_t* svr, char* buf, int len)
{
	buf[len] = 0;
	DecodeString(svr, buf, len);
	return 1; // update displayed info
}

int QUAKE2_IsFull(server_t* svr)
{
	if (svr->num_players && atoi( GetValue(svr, "maxclients") ) &&
			svr->num_players == atoi( GetValue(svr, "maxclients") ) )
		return 1;
	return 0;
}

int __stdcall Init(shared_t* info)
{
	types_t* t;

	
	GetServerAddr = info->GetServerAddr;
	GetServerPort = info->GetServerPort;

	HashInit(info->hashes,info->numHashes);
	s = HashSelectInt(HASH_GLOBAL,"Global","Socket");
	clan_id = HashSelectText(HASH_GLOBAL,"Settings","ClanId");
	
	t = info->types[0];
	t->type = 9;
	t->port = 31510;
	strcpy(t->name, "Kingpin: Life Of Crime");
	strcpy(t->path, "C:\\kingpin\\kingpin.exe");
	t->receive = KINGPIN_Receive;
	t->print_info = KINGPIN_PrintInfo;
	t->send = KINGPIN_Send;
	t->hostname = KINGPIN_Hostname;
	t->isFull = QUAKE2_IsFull;

	//HashInsertPtr(t,"funcs","isfull",QUAKE2_IsFull);

	(void*)t->iImage = LoadBitmap(
		HashSelectPtr(HASH_GLOBAL,"Status","Hinstance"),
		MAKEINTRESOURCE(IDB_GAMEICON)
	);

	return 1;
}

