/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include <windows.h>
#include <time.h>
#include "resource.h"
#include "stringtable.h"

#include "http.h"
#include "hash.h"
#include "main.h"


int WINAPI MOTD_DlgProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	int i,j;
	char* text, *l;
	switch (msg) {
	case WM_INITDIALOG:
		ShowWindow(GetDlgItem(hwnd,IDT_MESSAGE),SW_HIDE);
		l = (char*)lparam;
		text = malloc(strlen(l) * 2 + 2);

		for (i=0,j=0;i<(int)strlen(l)+1;i++)
		{
			if (l[i] == '\n' && l[i-1] != '\r') 
				text[j++] = '\r';
			text[j++] = l[i];
		}
				

		SetDlgItemText(hwnd,IDT_LONGMESSAGE,text);
		free(text);
		SetWindowText(hwnd,"Incoming Announcement");
		if (GetDlgItem(hwnd,IDB_ICON))
		{
			SendMessage(GetDlgItem(hwnd,IDB_ICON),BM_SETIMAGE,IMAGE_ICON,
				(LPARAM)LoadIcon(PROG_HINSTANCE,MAKEINTRESOURCE(IDI_ICON2)) );
		}
		break;
	case WM_COMMAND:
		if (wparam == IDOK) 
			EndDialog(hwnd,0);
		if (wparam == IDB_ICON)
			ShellExecute(NULL,NULL,IDS_WEBURL,NULL,NULL,0);
		return 0;
	case WM_CLOSE:
		EndDialog(hwnd,0);
	}
	return 0;
}

void MOTD_DialogBox(char* str) {
	DialogBoxParam(NULL,MAKEINTRESOURCE(IDD_WELCOME),PROG_HWND,MOTD_DlgProc,(LPARAM)str);
	return;
}

void MOTD_Receive(HTTP_DATA* data) {
	
	int i;
	char* str;
	char* search = "\r\nLast-Modified: ";
	char date[128];
	char *temp;

	WRITE_DEBUG("memcmp() motd.c(47)");
	for (str = data->header;memcmp(str,"\r\n\r\n",4);str++)
		if (memcmp(str,search,strlen(search)) == 0) {
			memcpy(date,str+strlen(search),120);
			for (i=0;i<120;i++)
				if (date[i] == '\r') {
					date[i] = 0;
					break;
				}
			temp = HashSelect(HASH_GLOBAL,"Settings","LastMOTD",HASH_STRING);
			if (strcmp(date,temp))
			{
				if (strlen(temp))
					MOTD_DialogBox(data->data);
				HashInsert(HASH_GLOBAL,"Settings","LastMOTD",date,HASH_STRING);
				return;
			}
		}
	return;
}

void MOTD_Download(void* unused)
{
	HTTP_DATA* data;
	static char buf[128];
	(void*)unused;

	WRITE_DEBUG("MOTD: download");
	data = calloc(sizeof(HTTP_DATA),1);
	
	data->windowed = 0;
	//LoadString(PROG_HINSTANCE,IDS_MOTDURL,buf,128);
	data->url = IDS_MOTDURL;
	data->func = MOTD_Receive;
	data->ptr = NULL;
	HTTP_Download(data);
}

void MOTD_NEW_Download(void* unused)
{
	HTTP_DATA* data;
	static char buf[128];
	(void*)unused;

	WRITE_DEBUG("NEW MOTD: download");
	data = calloc(sizeof(HTTP_DATA),1);
	
	data->windowed = 0;
	//LoadString(PROG_HINSTANCE,IDS_NEWURL,buf,128);
	data->url = IDS_NEWURL;
	data->func = NULL;
	data->ptr = NULL;
	HTTP_Download(data);
}

