/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include <windows.h>
#include <stdio.h>
#include "resource.h"
#include "stringtable.h"

#include "hash.h"
#include "main.h"
#include "hashdef.h"
#include "progcfg.h"

int WINAPI MSG_DlgProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	//char buf[128];
//	int i;

	switch (msg) {
	case WM_INITDIALOG:
		if (GetDlgItem(hwnd,IDB_ICON))
		{
			SendMessage(GetDlgItem(hwnd,IDB_ICON),BM_SETIMAGE,IMAGE_ICON,
				(LPARAM)LoadIcon(PROG_HINSTANCE,MAKEINTRESOURCE(IDI_ICON2)) );
		}
		if (lparam)
		{
			if (GetDlgItem(hwnd,IDT_LONGMESSAGE))
			{
				ShowWindow(GetDlgItem(hwnd,IDT_MESSAGE),SW_HIDE);
				SetDlgItemText(hwnd,IDT_LONGMESSAGE,(char*)lparam);
			}
			else
				SetDlgItemText(hwnd,IDT_MESSAGE,(char*)lparam);

		}
		else
			ShowWindow(GetDlgItem(hwnd,IDT_LONGMESSAGE),SW_HIDE);

		//LoadString(PROG_HINSTANCE,IDS_TITLE,buf,128);
		SetWindowText(hwnd,IDS_TITLE);

		/* DEBUG */
		/*sprintf(buf, "DEBUG:\n %d hashes",G_NumHashes);
		SetDlgItemText(hwnd,IDT_DEBUG,buf);*/
		return 0;

	case WM_COMMAND:
		if (wparam == IDB_PROGCFG) {
			EndDialog(hwnd,2);
			
		}

		if (wparam == IDB_ICON)
		{
			ShellExecute(NULL,NULL,"http://www.serverquery.com/",NULL,NULL,0);
			return 0;
		}
		if (wparam == IDOK) {
			EndDialog(hwnd,0);
		}
		return 0;
	case WM_CLOSE:
		EndDialog(hwnd,0);
	}
	return 0;
}

int MSG_DialogBox(HINSTANCE hinstance, HWND hwnd, char* error, int window)
{	
	int i,j;
	char* text = error;

	/*if (window == IDD_WELCOME) {
		if (HashSelectInt(HASH_GLOBAL,"Status","ShownWelcome"))
			return 0;
		else HashInsertInt(HASH_GLOBAL,"Status","ShownWelcome",1);
	}*/

	if (error)
	{
		text = malloc(strlen(error)*2+1);
		for (i=0,j=0;i<(int)strlen(error);i++,j++)
		{
			if (error[i] == '\n' && error[i-1] != '\r')
			{
				text[j++] = '\r'; text[j] = '\n';
			}
			else text[j] = error[i];
		}
		text[j] = 0;
	}


	i = DialogBoxParam(PROG_HINSTANCE,MAKEINTRESOURCE(window),PROG_HWND,MSG_DlgProc,(LPARAM)text);

	free(text);

	if (i == 2)
		PROGCFG_DialogBox();
	else
		HashDelete(HASH_GLOBAL,"Status","ProgErrorRejoin");

	return 0;
}

