/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include <string.h>
#include "servers.h"

int SearchRecords(server_t* svr, int id)
{
	int i, value;
	int num_records = HSI(svr,"info","num_records");

	for (i=0;i<num_records;i++) 
	{
		if (!strcmp(HST(svr,"name",(HASH_PARAM)id), 
			HST(svr,"RecordName",(HASH_PARAM)i) ))
		{
			HII(svr,"RecordChanged",(HASH_PARAM)i,1);
			value = HSI(svr,"RecordFrags",(HASH_PARAM)i);
			HII(svr,"RecordFrags",(HASH_PARAM)i, HSI(svr,"frags",(HASH_PARAM)id) );
			return value;
		}
	}
	HIT(svr,"RecordName", (HASH_PARAM)i,
		HST(svr,"name",(HASH_PARAM)id) );
	HII(svr, "RecordFrags", (HASH_PARAM)i, 
			HSI(svr,"frags",(HASH_PARAM)id) );
	HII(svr,"RecordChanged",(HASH_PARAM)i,1);
	HII(svr,"info","num_records",num_records + 1);
	return 0;
}

void CleanRecords(server_t* svr)
{
	int i; //, j;
	int num_records = HSI(svr,"info","num_records");

	for (i=0;i<num_records;i++)
	{
		if (!HSI(svr,"RecordChanged",(HASH_PARAM)i))
		{
			HashDelete(svr,"RecordName",(HASH_PARAM)i);
			HashDelete(svr,"RecordFrags",(HASH_PARAM)i);
			HashDelete(svr,"RecordChanged",(HASH_PARAM)i);

			/*for (j=i;j<num_records-1;j++)
				svr->records[j] = svr->records[j+1];*/
			num_records--;
		}
		else HII(svr,"RecordChanged",(HASH_PARAM)i,0);
	}
	HII(svr,"info","num_records",num_records);
}
