/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include <stdio.h>
#include <windows.h>
#include "types.h"
#include "progcfg.h"
#include "resource.h"
#include "main.h"
#include "list.h"
#include "ctype.h"
#include "disk.h"
#include <time.h>
#include <commctrl.h>
#include "ui.h"




// main.c
server_t* GetSLServer(void);

/*
void ServersGetAddrStr(server_t* svr, char* out)
{
	unsigned long addr;
	int port;

	addr = GetServerAddr(svr->ipaddr);
	port = GetServerPort(svr->ipaddr, GetServerType(svr->type)->port );

	sprintf(out,"%s:%d"
*/


// ***
// This function is called once per 'frame'
// ***

static int allow_list_updates = 1;
void ServersListUpdateEnable(int setting) {
	char buf[128];
	if (setting == 0)
	{
		sprintf(buf,"Decrementing (currently %d)",allow_list_updates);
		WRITE_DEBUG(buf);
		allow_list_updates --;		
	}
	else if (allow_list_updates<1)
	{
		sprintf(buf,"Incrementing (currently %d)",allow_list_updates);
		WRITE_DEBUG(buf);
		allow_list_updates ++;
	}
}

void ServersListUpdate(int updates)
{
	list_t* list;
	static executing = 0;
	//server_t* svr;

	WRITE_DEBUG("Beginning list update");

	if (executing)
		return;

	executing = 1;
	// Notify all lists of update
	list = HashReset(HASH_GLOBAL,"Lists",HASH_PTR);
	while (list)
	{
		if (GroupOfList(list)->every_update)
			GroupOfList(list)->every_update(list);
		list = HashNext(HASH_GLOBAL,"Lists",HASH_PTR);
	}

	if (updates > 0) {
		allow_list_updates = updates - 1;
		executing = 0;
		return;
	}

	if (allow_list_updates < 1)
	{
		executing = 0;
		return;
	}
	

	// This is no longer actually necessary

	// CREATE LIST OF ALL SERVERS
	/*
	HashFree(HASH_GLOBAL,"AllServers");

	list = HashReset(HASH_GLOBAL,"Lists",HASH_PTR);
	while (list)
	{
		HashInsertHash(HASH_GLOBAL,"AllServers",list,"servers");
		list = HashNext(HASH_GLOBAL,"Lists",HASH_PTR);
	}
	*/

	// Notify all lists of post update
	

	list = HashReset(HASH_GLOBAL,"Lists",HASH_PTR);
	while (list)
	{
		allow_list_updates = 0;
		if (GroupOfList(list)->major_update)
			GroupOfList(list)->major_update(list);
		list = HashNext(HASH_GLOBAL,"Lists",HASH_PTR);
	}
	allow_list_updates = 1;

	/* for (svr = HashReset(HASH_GLOBAL,"AllServers",HASH_PTR);svr;
		svr = HashNext(HASH_GLOBAL,"AllServers",HASH_PTR))
			;
	*/
	executing = 0;
	return;
}

#define LIST_OFFSET(x) ((int) ((list_t*)NULL)->x)

/*void ServerSetItem(server_t* svr, int insert)
{
	TV_INSERTSTRUCT tv;
	ITEM_TYPE* it;
	char buf[128];
	LV_ITEM lvi;
	int i;
	void *ptr;
	LV_FINDINFO lvf;

	HWND hwnd = HashSelect(HASH_GLOBAL,"Global","ServersTree",HASH_PTR);

	if (HSIG("Settings","DualPane") == 0)
	{

	list_t* list = svr->list;
	
	if ((it = HashSelectPtr(svr, "Ptrs", "Item_type")) == NULL)
	{
		it = (ITEM_TYPE*) calloc(sizeof(ITEM_TYPE),1);
		it->type = IT_SERVER;
		it->ptr = svr;
		HashInsertPtr(svr,"Ptrs","Item_type",it);
	}

	//tv.hParent = HashLookupP("HTREEITEM",name);
	tv.hParent = list->hTreeItem;
	tv.hInsertAfter = TVI_LAST;

	strcpy(buf,svr->name);
	HashInsertText(svr,"temp","hostname",buf);
	tv.item.pszText = HashSelectText(svr,"temp","hostname");
	tv.item.lParam = (LPARAM)it;
	tv.item.iImage = HashSelectInt(NULL,"Indexes","Blank");
	tv.item.iSelectedImage = HashSelectInt(NULL,"Indexes","Blank");

	if (GetServerType(svr->type)->iImage) 
		tv.item.iImage = tv.item.iSelectedImage = GetServerType(svr->type)->iImage;

	tv.item.mask = TVIF_TEXT | TVIF_PARAM | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
	if (insert || svr->hTreeItem == NULL)
		svr->hTreeItem = TreeView_InsertItem(hwnd,&tv);
	else {
		tv.item.hItem = svr->hTreeItem;
		TreeView_SetItem(hwnd,&(tv.item));
	}
	// FIXME
	if (strcmp(GroupOfList(list)->name,"LANServers") == 0)
	{
		TreeView_SortChildren(HashSelect(HASH_GLOBAL,"Global","ServersTree",HASH_PTR),
			HashSelect(HASH_GLOBAL,"HTREEITEM","LANServers",HASH_PTR),0);
	}
	}
	else if (svr->list == HashSelectPtr(HASH_GLOBAL,"Status","CurrentList")) {
		//if (HashSelectInt(HASH_GLOBAL,"Status","DualPane"))
		i = ListView_GetItemCount(HSPG("Global","ServersLV"));

		if (insert == 0)
		{
			lvf.flags = LVFI_PARAM;
			lvf.lParam = (long)svr;
			i = ListView_FindItem(HSPG("Global","ServersLV"),-1,&lvf);

			// No idea why, but obviously this triggers an item change 
			HIIG("Status","IgnoreItemChange",1);
			ListView_SetItemText(HSPG("Global","ServersLV"),
				i,0,svr->name);

			HIIG("Status","IgnoreItemChange",0);

			ListView_RedrawItems(
				HashSelectPtr(HASH_GLOBAL,"Global","ServersLV"),
				i,
				i
			);
			//RedrawWindow(HSPG("Global","ServersLV"),NULL,NULL,RDW_INVALIDATE);
		}
		if (insert == 1)
		{
			
			
			lvi.mask = LVIF_TEXT | LVIF_PARAM | LVIF_IMAGE;
			if (GetServerType(svr->type)->iImage) 
				lvi.iImage = GetServerType(svr->type)->iImage;
			else 
				lvi.iImage = 0;
			
			lvi.iItem = i;
			lvi.iSubItem = 0;
			lvi.state = lvi.stateMask = 0;
			lvi.pszText = svr->name;
			lvi.lParam = (long)svr; //LPSTR_TEXTCALLBACK; //(long)svr;
			ListView_InsertItem(HashSelectPtr(HASH_GLOBAL,"Global","ServersLV"),&lvi);
		}
	}
}
*/
server_t* AddServer(list_t* list, server_t* svr) {
	TV_ITEM item;
	char buf[2048];

	if (svr == NULL)
		return NULL;

	// Mark as having children if using single-pane view
	if (HSIG("Settings","DualPane") == 0)
	{
		item.hItem = list->hTreeItem;
		item.mask = TVIF_CHILDREN;
		item.cChildren = 1;
		TreeView_SetItem(PROG_TREEVIEW,&item);
	}

	// Double-linked 

	sprintf(buf,"Adding to list '%s' server '%s' (%s)",list->desc,svr->name,svr->ipaddr);
	WRITE_DEBUG(buf);
	HashInsert(list,"servers",HASH_ANY,svr,HASH_PTR);
	
	/* Add to hash of lists to which this server belongs */
	if (HashExistsValue(svr,"lists",list,HASH_PTR) == (HASH_PARAM)-1)
		HashInsert(svr,"lists",HASH_ANY,list,HASH_PTR);
	
	ServersListUpdate(0);
	UI_AddServer(svr,list);	

	return svr;
}

void FreeServer(server_t* server)
{
	void* ptr;
	
	//WRITE_DEBUG("Free'ing server");
	if ((ptr = HashSelectPtr(server,"ptrs","item_type")) != NULL)
	{
		free (ptr);
		WRITE_DEBUG("Free'ing item_type");
	}

	// Remove from global server list
	HashDeleteValue(HASH_GLOBAL,"AllServers",server,HASH_PTR);

	DropRequestCache(server);

	//WRITE_DEBUG("Free'ing name");
	free (server->name);
	//WRITE_DEBUG("Free'ing ip addr");
	free (server->ipaddr);
	//WRITE_DEBUG("Free'ing players");
//	free (server->players);
	//WRITE_DEBUG("Free'ing records");
//	free (server->records);
	
	//WRITE_DEBUG("Free'ing associated hashes");
	HashFreeAssoc(server);
	//WRITE_DEBUG("Free'ing server struct");
	free (server);
	return;
}


void DeleteServer(server_t* server, void* fromList) {
	TV_ITEM item;
	char buf[128];
	list_t* list;	

	sprintf(buf,"Deleting server '%s'",server->name);
	WRITE_DEBUG(buf);
	timeTaken();

	UI_DeleteServer(server,fromList);

	list = fromList;

	HashDeleteValue(list,"servers",server,HASH_PTR);
	timeTaken();

	// If all servers have been deleted, close the folder 
	if (HashCount(list,"servers") == 0)
	{
		item.hItem = ((list_t*)list)->hTreeItem;
		item.mask = TVIF_CHILDREN | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
		item.cChildren = 0;
		item.iImage = item.iSelectedImage = HashSelectInt(HASH_GLOBAL,"Indexes","Closed");
		TreeView_SetItem(PROG_TREEVIEW,&item);

		timeTaken();
	}

	// If this server was current, change the current to none
	if (CURRENT_SERVER == server && CURRENT_LIST == list)
		SET_CURRENT_SERVER(NULL);
	timeTaken();	

	// Remove this list as a container
	HashDeleteValue(server,"lists",list,HASH_PTR);

	// if server is no longer in use, remove it
	if (HashCount(server,"lists") == 0)
	{
		FreeServer(server);
		timeTaken();
	}

	// Clean up server lists
	ServersListUpdate(0);
	timeTaken();


	

	
}

// special, as it cleans up the treeview as well
void DeleteServerList(list_t* list) {
	server_t* svr;
	list_t* other;
	
	// Dualpane == 0
	if (HSIG("Settings","DualPane") == 0)
		TreeView_Expand(PROG_TREEVIEW,list->hTreeItem,TVE_COLLAPSE);
	// Dualpane == 1
	else if (list == HashSelectPtr(HASH_GLOBAL,"Status","CurrentList"))
		ListView_DeleteAllItems(HSPG("Global","ServersLV"));



	ServersListUpdateEnable(0);
	
	for (other = HashReset(HASH_GLOBAL,"Lists",HASH_PTR); other;)
	{
		if (HashSelectPtr(other,"ptrs","parent") == list) {
			//WRITE_DEBUG("Deleting child list");
			DeleteList(other);
			timeTaken();
			other = HashReset(HASH_GLOBAL,"Lists",HASH_PTR);
		}
		else 
			other = HashNext(HASH_GLOBAL,"Lists",HASH_PTR);
	}
		
	while (svr = HashReset(list, "servers", HASH_PTR) ) {
		DeleteServer(svr,list);
	//	Sleep(500);
	}
	
	ServersListUpdateEnable(1);
	ServersListUpdate(0);
}


server_t* NewServer(char* name, char* ipaddr, char* qstat_type)
{
	server_t* temp;

	temp = (server_t*) calloc(sizeof(server_t), 1); // 156bytes

	/*if (HashAlloc(temp,"items",32) == NULL) { // 32 * 32 
		free(temp);
		return NULL;
	}*/

	temp->name = (char*) malloc(strlen(name) + 1);
	temp->ipaddr = (char*) malloc(strlen(ipaddr) + 1);
	temp->gametype = GetServerType_qstat(qstat_type);
	strcpy(temp->name, name);
	strcpy(temp->ipaddr, ipaddr);
//	temp->players = (player_t*) calloc(sizeof(player_t), 32); //20k
//	temp->records = (player_t*) malloc(sizeof(player_t) * 32); //20k
//	temp->max_players = 32;

	HashInsertPtr(HASH_GLOBAL,"AllServers",HASH_ANY,temp);
	return temp;
}


void ServersClose(void)
{
	SaveToDisk();
	return;
}


static server_t* clippedServer;

void ServerClipboardEmpty(void)
{
	if (clippedServer)
		FreeServer(clippedServer);
}
void ServerCopy(server_t* svr)
{
	if (clippedServer)
		FreeServer(clippedServer);
	clippedServer = NewServer(svr->name,svr->ipaddr,svr->gametype->qstat_type);
}

void ServerCut(server_t* svr)
{
	ServerCopy(svr);
	DeleteServer(svr,CURRENT_LIST);
}

void ServerAddFavourites(server_t* svr)
{
	list_t* list;
	
	list = HashFind(HASH_GLOBAL,"Lists","Favourites",(int)GroupOfList(NULL)->name);
	AddServer(list,NewServer(svr->name,svr->ipaddr,svr->gametype->qstat_type));
	TreeView_Expand(HashSelect(HASH_GLOBAL,"Global","ServersTree",HASH_PTR),list->hTreeItem,TVE_EXPAND);
}

int ServerPastable(list_t* list)
{
	if (clippedServer)
		return 1;
	return 0;
}
void ServerPaste(list_t* list)
{
	AddServer(list,NewServer(clippedServer->name,clippedServer->ipaddr,clippedServer->gametype->qstat_type));
	TreeView_Expand(HashSelect(HASH_GLOBAL,"Global","ServersTree",HASH_PTR),list->hTreeItem,TVE_EXPAND);
}
