/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include <windows.h>
#include <commctrl.h>
#include "types.h"
//#include "servers.h"
#include "resource.h"
#include <stdio.h>



static HWND lv;
static LV_ITEM lvi;
static int id;
static int add;

void ServinfoInit(server_t* svr)
{
	lv = HashSelectPtr(HASH_GLOBAL,"Global","ServerInfoLV");
	
	if (svr == NULL 
		|| (HSIG("Settings","ExtraServInfo") && HSPG("Status","ServerInfoSvr") != svr)
		|| (HashSelectText(HASH_GLOBAL,"Status","ServerInfoType") != svr->gametype->qstat_type)
		)
	{
		add = 1;
		ListView_DeleteAllItems(lv);
		HashDeleteAll(HASH_GLOBAL,"ServerInfo");
	}
	else add = 0;

	HashInsertPtr(HASH_GLOBAL,"Status","ServerInfoSvr",svr);
	HashInsertText(HASH_GLOBAL,"Status","ServerInfoType",svr ? svr->gametype->qstat_type : "");

	id = 0;

	memset(&lvi,0,sizeof(LV_ITEM));
	lvi.mask = LVIF_TEXT;
}

void ServinfoAdd(char* name, char* value)
{
	lvi.pszText = name; lvi.iItem = id; 
	if (add) 
		ListView_InsertItem(lv,&lvi); 
	else if (strcmp(name,"Ping") == 0 || strcmp(value,
			HashSelectText(HASH_GLOBAL,"ServerInfo", (HASH_PARAM)id)) != 0) 
		ListView_RedrawItems(lv,id,id); 
	HashInsertText(HASH_GLOBAL,"ServerInfo",(HASH_PARAM)id++,value); 
}
	

void PlayerinfoInit(server_t* svr)
{
	lv = HashSelectPtr(HASH_GLOBAL,"Global","PlayerInfoLV");
	
	/*if (HashSelectInt(HASH_GLOBAL,"Status","ServerInfoType") != svr->type)
	{*/
		add = 1;
		ListView_DeleteAllItems(lv);
		HashDeleteAll(HASH_GLOBAL,"PlayerInfoName");
		HashDeleteAll(HASH_GLOBAL,"PlayerInfoPing");
	/*}
	else add = 0;*/

	//HashInsertInt(HASH_GLOBAL,"Status","ServerInfoType",svr->type);

	id = 0;

	memset(&lvi,0,sizeof(LV_ITEM));
	lvi.mask = LVIF_TEXT;
}

void PlayerinfoAdd(char* name, int kills, int change, int ping)
{
	char buf[32];

	sprintf(buf,"%d",kills);
	if (kills == -2000)
		strcpy(buf, "");
	else if (kills <= -3000) {
		sprintf(buf, "%d pt",abs(kills) - 3000);
		if (kills != -3000)
			strcat(buf,"s");
	}

	if (change != 0)
		sprintf(buf+strlen(buf)," (%c%d)",(change>0?'+':' '),change);

	lvi.pszText = buf; lvi.iItem = id; 
	if (add) 
		ListView_InsertItem(lv,&lvi); 
	/*else if (strcmp(name,
			HashSelectText(HASH_GLOBAL,"ServerInfo", (HASH_PARAM)id)) != 0) 
		ListView_RedrawItems(lv,id,id); */

	HashInsertText(HASH_GLOBAL,"PlayerInfoName",(HASH_PARAM)id,name); 
	if (ping == -1000)
		HashInsertText(HASH_GLOBAL,"PlayerInfoPing",(HASH_PARAM)id,"?");
	else if (ping == -2000)
		HashInsertText(HASH_GLOBAL,"PlayerInfoPing",(HASH_PARAM)id,"");
	else HashInsertInt(HASH_GLOBAL,"PlayerInfoPing",(HASH_PARAM)id,ping);
	
	id++;
}	


