/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include <windows.h>
#include "resource.h"

#include "servers.h"
#include "list.h"
#include "main.h"
#include "systray.h"


// hack hack hack
#define WM_NOTIFYICON	20000
#define ID_SYSTRAY		20001

static NOTIFYICONDATA nid;

int WINAPI SystrayProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	if (HashSelectInt(HASH_GLOBAL,"Settings","Systray") == 0)
		return 0;

	if (msg == WM_NOTIFYICON
		&& lparam == WM_LBUTTONDBLCLK)  
	{
		if (!IsWindowVisible(hwnd))
			ShowWindow(hwnd,SW_SHOW);
		ShowWindow(hwnd,SW_RESTORE);
		SetForegroundWindow(hwnd);
		return  1;
	}

	if (msg == WM_SIZE && wparam == SIZE_MINIMIZED)
	{
		if (IsWindowVisible(hwnd))
			ShowWindow(hwnd,SW_HIDE);
		return 1;
	}
	return 0;

}

void SystrayUpdate(void) {
	HWND hwnd;
	int current, old;
	int visible;

	old = HashSelectInt(HASH_GLOBAL,"Status","Systray");
	current = HashSelectInt(HASH_GLOBAL,"Settings","Systray");

	if (old == current)
		return;

	visible = IsWindowVisible(PROG_HWND);

	if (old) {
		CreateMainWindow(NULL);
		ListRebuildTreeview();
		if (visible)
			LoadWindowPosition(PROG_HWND,SW_SHOW);
		DestroyWindow(HashSelectPtr(HASH_GLOBAL,"Global","SystrayHide"));
		HashDelete(HASH_GLOBAL,"Global","SystrayHide");
		SystrayClose();
		return;
	}

	
	
	hwnd = CreateDialog(PROG_HINSTANCE,MAKEINTRESOURCE(IDD_ERROR),
		NULL,SystrayProc);
	HashInsertPtr(HASH_GLOBAL,"Global","SystrayHide",hwnd);

	CreateMainWindow(hwnd);
	ListRebuildTreeview();
		
	if (visible)
			LoadWindowPosition(PROG_HWND,SW_SHOW);
	else LoadWindowPosition(PROG_HWND,SW_HIDE);
		
	nid.cbSize = sizeof(NOTIFYICONDATA);
	nid.hWnd = PROG_HWND;
	nid.uID = ID_SYSTRAY;
	nid.uFlags = NIF_TIP | NIF_ICON | NIF_MESSAGE;
	nid.hIcon = LoadIcon(PROG_HINSTANCE,MAKEINTRESOURCE(IDI_ICON2));
	nid.uCallbackMessage = WM_NOTIFYICON;
	strcpy(nid.szTip,"Server Query");
	Shell_NotifyIcon(NIM_ADD,&nid);
	HashInsertInt(HASH_GLOBAL,"Status","Systray",1);
	
}

void SystrayClose(void) {
	if (HashSelectInt(HASH_GLOBAL,"Status","Systray") == 0)
		return;

	Shell_NotifyIcon(NIM_DELETE,&nid);
	HashInsertInt(HASH_GLOBAL,"Status","Systray",0);
	return;
}