#include <windows.h>
#include "servers.h"
#include "limits.h"

struct types_s {
	//int type;
	short port;
	char name[128];
	char path[MAX_PATH];
	char qstat_type[16];
	char gamespy_type[64];
	char* mod_cvar;
	void (*send) (SOCKET s, server_t*, short port);
	int (*receive) (server_t*, char* data, int len);
	int (*isPacketFrom) (server_t* svr, SOCKADDR*);
	void (*print_info) (server_t*, HWND, int);
	char* (*hostname) (server_t*);
	//char* (*cmdline) (server_t*);
	void* module;
	int other[28];
	short recv_port;
	char unused1[2];
	int iImage;
	char* parameters;
	char unused2[3];
	char disallowPath;
	int bc_socket;
	
	int invalid;
	int (*isfull) (server_t* svr);
	int protocol;
	char registrykey[256];
	char keyfile[256];
	char alt_keyfile[256];
	char connect_template[256];
	short port_offset;
	char password_format[256];
	char password_var[128];
	char mod_format[256];
	char mod_var[128];
	char mod_default[128];
};

typedef struct types_s types_t;


extern types_t *server_types[MAX_SERVER_TYPES];
extern int num_server_types;
types_t* GetServerType(int type);
types_t* GetServerType_qstat(char* type);
types_t* GetServerType_gamespy(char* type);

void RequestServerStatus(server_t* svr);
void RequestLANServersStatus(void);
void RefreshLANServers(void);

void RegisterGameTypes(void);